#include <pcl/point_cloud.h>
#include <pcl/point_types.h>
#include <pcl/visualization/cloud_viewer.h>

#include <iostream>
#include <fstream>
#include <vector>

using namespace std;
int main (int argc, char** argv)
{
	for(float resolution=0.1f; resolution<1.1f; resolution+=0.1f)
	{
	struct timeval startTime, endTime; long diff;
	gettimeofday(&startTime, NULL); //start the timer
	string path="/media/Storage/gedebinindexsub/"; //location of the index you wish to load
	pcl::PointCloud<pcl::PointXYZ>::Ptr cloud (new pcl::PointCloud<pcl::PointXYZ>); //empty point cloud pointer
	ifstream fin((path+"index.txt").c_str()); //open the root index file
	//read in cloud size and bounding box
	long cloud_size;
	fin >> cloud_size;
	float min_x, max_x, min_y, max_y, min_z, max_z;
	fin >> min_x >> max_x >> min_y >> max_y >> min_z >> max_z;

	vector<ifstream*> partial; vector<int> partial_size;
	vector<ifstream*> entire; vector<int> entire_size;
	//float resolution = 1.0f;	 //the desired resolution of the region as a fraction of the total number of available points
	//user set region for extraction
	//float x_start=-87.4886, x_end=-36.8698, y_start=30.0367, y_end=79.6752, z_start=-7.49669, z_end=8.08327; //mosque entire
	//float x_end=-30.0, y_start=30.0, y_end=80.0, z_start=-8.0, z_end=9.0; //mosque entire2
	//float x_start=-100.0, x_end=-20.0, y_start=20.0, y_end=90.0, z_start=-20.0, z_end=20.0; //mosque entire+1
	//float x_start=-50.0, x_end=-30.0, y_start=40.0, y_end=70.0, z_start=-6.0, z_end=5.0; //tree stump
	//float x_start=-60.0, x_end=-20.0, y_start=30.0, y_end=70.0, z_start=-10.0, z_end=10.0; //tree stump+1
	//float x_start=-60.0, x_end=-30.0, y_start=40.0, y_end=60.0, z_start=-10.0, z_end=10.0; //pillar
	//float x_start=-105.0, x_end=-60.0, y_start=-60.0, y_end=-20.0, z_start=-5.0,z_end=3.0; //small mosque
	//float x_start=-90.0, x_end=-80.0, y_start=-50.0, y_end=-40.0, z_start=-5.0,z_end=3.0; //small mosque
	//float x_start=-155.410202, x_end=71.37434387, y_start=-97.22502136, y_end=98.39588165, z_start=-41.2867775,z_end=70.65890503; //gede
	//float x_start=-160.0, x_end=80.0, y_start=-100.0, y_end=100.0, z_start=-50.0,z_end=80.0; //gede+1
	//float x_start=-70.0, x_end=-50.0, y_start=40.0, y_end=60.0, z_start=-10.0, z_end=10.0; //gede-pillar nice region
	//float x_start=-90.0, x_end=-40.0, y_start=30.0, y_end=70.0, z_start=-10.0, z_end=10.0; //gede-pillar nice region with well
	float x_start=-80.0, x_end=-70.0, y_start=-50.0, y_end=-45.0, z_start=-10.0, z_end=10.0; //high badness
	//float x_start=-(50.0+i),x_end=-30.0, y_start=(40.0-i), y_end=60.0, z_start=-10.0, z_end=(10.0+i); //gede-pillar nice region with i
	//float x_start=-180.0,x_end=350.0, y_start=-250.0, y_end=970.0, z_start=-70.0, z_end=100.0; //jordan
	//float x_start=-180.0,x_end=100.0, y_start=500.0, y_end=970.0, z_start=-70.0, z_end=100.0; //jordan2
	//float x_start=-90.0, x_end=-30.0, y_start=30.0, y_end=(35.0+offset), z_start=-10.0, z_end=10.0; //mosque varying size
	//float x_start=-90.0, x_end=-80.0+offset, y_start=40.0, y_end=60.0, z_start=-10.0, z_end=10.0; //gede-pillar nice region -90 to -40
	
	     
	
	float a,b,c,d,e,f;
	string filename;
	int numpoints;
	while(fin >> a >> b >> c >> d >> e >> f)
	{
		fin >> filename;
		//filename+=".new"; //the reordered file
		fin >> numpoints;
		if(numpoints>0 && x_start <= a && a < x_end && y_start <= c && c < y_end && z_start <= e && e < z_end)
		{
			if(b<x_end && d<y_end && f<z_end)
			{
				entire.push_back( new ifstream((path+filename).c_str(), ios::binary) );
				entire_size.push_back( numpoints );
			}
			else
			{
				partial.push_back( new ifstream((path+filename).c_str(), ios::binary) );
				partial_size.push_back( numpoints);
			}
		}
	}
	fin.close();
	gettimeofday(&endTime, NULL);
	diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
	diff += (endTime.tv_usec - startTime.tv_usec);
	cout << (diff / 1000L) << " ";
	
	//cout << "Entire: " << entire.size() << endl;
	//cout << "Partial: " << partial.size() << endl;
	//add the relevant points to the cloud
	for(int i=0; i<entire.size(); i++)
	{
		float x,y,z;
		int numadded = 0; int numneeded = resolution*entire_size[i];
		while(true)
		{
			entire[i]->read( reinterpret_cast<char*>( &x ), sizeof x );
			if(entire[i]->eof() || numadded>=numneeded)break;
			entire[i]->read( reinterpret_cast<char*>( &y ), sizeof y );
    		entire[i]->read( reinterpret_cast<char*>( &z ), sizeof z );
			pcl::PointXYZ newpoint(x,y,z);
			cloud->push_back (newpoint);
			numadded++;
		}
		entire[i]->close();
	}
	gettimeofday(&endTime, NULL);
	diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
	diff += (endTime.tv_usec - startTime.tv_usec);
	cout << (diff / 1000L) << " ";
	for(int i=0; i<partial.size(); i++)
	{
		float x,y,z;
		int numadded = 0; int numneeded = resolution*entire_size[i];
		while(true)
		{
			partial[i]->read( reinterpret_cast<char*>( &x ), sizeof x );
			if(partial[i]->eof() || numadded>=numneeded)break;
    		partial[i]->read( reinterpret_cast<char*>( &y ), sizeof y );
    		partial[i]->read( reinterpret_cast<char*>( &z ), sizeof z );
			pcl::PointXYZ newpoint(x,y,z);
			if(x_start<=x && x<=x_end && y_start<=y && y<=y_end && z_start<=z && z<=z_end)
			{
				cloud->push_back (newpoint);
				numadded++;
			}
		}
		partial[i]->close();
	}
	gettimeofday(&endTime, NULL);
	diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
	diff += (endTime.tv_usec - startTime.tv_usec);
	cout << (diff / 1000L) << " ";

	cout << cloud->width << endl;
	}

	cout << endl;
  
	//visualise point cloud
	/*pcl::visualization::CloudViewer viewer ("Simple Cloud Viewer");
	viewer.showCloud (cloud);
	while (!viewer.wasStopped ())
	{
	}*/

	
}
