#include <iostream>
#include <fstream>
#include <vector>
#include <sstream>
#include <math.h>
#include <sys/time.h>

using namespace std;
int main(int argc, char** argv)
{
	struct timeval startTime, endTime; long diff;
	gettimeofday(&startTime, NULL); //start the timer
	
	string inputfile = "/media/Storage/jordan.xyz"; //xyz file
	string indexlocation = "/media/Storage/jordanbinindex/"; //output directory
	ifstream fin(inputfile.c_str());
	float min_x, max_x, min_y, max_y, min_z, max_z;
	//long cloud_size = 59242631; //mosque.xyz
	//long cloud_size = 224162339; //smallmosque.xyz
	//long cloud_size = 1295652815; //test.xyz
	//long cloud_size = 2403821971; //smallmosque.xyz
	//long cloud_size = 2403821971; //gede.xyz
	long cloud_size = 1;
		
	//find bounding box so we can create octree
	cout << "Calculating bounding box" << endl;
	//read first line and initialise
	float x,y,z;
	fin >> min_x; fin >> min_y; fin >> min_z;
	max_x = min_x; max_y = min_y; max_z = min_z;
	while(fin >> x >> y >> z)
	{
		if(x<min_x)min_x=x;
		if(x>max_x)max_x=x;
		if(y<min_y)min_y=y;
		if(y>max_y)max_y=y;
		if(z<min_z)min_z=z;
		if(z>max_z)max_z=z;
		cloud_size++;
	}
	fin.close();
	cout << "Number of points " << cloud_size << endl;
	gettimeofday(&endTime, NULL);
	diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
	diff += (endTime.tv_usec - startTime.tv_usec);
	cout << "Time to calculate bounding box: " << (diff / 1000L) << " ms" << endl;
	
	gettimeofday(&startTime, NULL); //restart the timer
	cout << "Building index" << endl;
	float resolution = 4.0f;
	ofstream index( (indexlocation+"index.txt").c_str() );
	index.precision(10);
	index << cloud_size << endl;
	index << min_x << " " << max_x << " " << min_y << " " << max_y << " " << min_z << " " << max_z << endl;
	
	int xmult=(int) ceil((max_x-min_x)/resolution); cout << xmult << endl;
	int ymult=(int) ceil((max_y-min_y)/resolution); cout << ymult << endl;
	int zmult=(int) ceil((max_z-min_z)/resolution); cout << zmult << endl;
	
	int numberofpoints[xmult*ymult*zmult];
	for(int i=0; i<xmult*ymult*zmult; i++) numberofpoints[i]=0; //initialise to zero else you get weird numbers
	vector<ofstream*> voutput;
	voutput.resize(xmult*ymult*zmult);
		
	ifstream fin2(inputfile.c_str()); //reopen input file to read points
	for(long i=0; i<cloud_size; i++)
	{
		fin2 >> x >> y >> z;
		int xindex = (x-min_x)/resolution;
		int yindex = (y-min_y)/resolution;
		int zindex = (z-min_z)/resolution;
		int pos = ymult*zmult*xindex + zmult*yindex + zindex;
		if(voutput[pos]==NULL)
		{
			stringstream ss;
			ss << indexlocation << "s" << pos << ".xyz";
			voutput[pos] = new ofstream(ss.str().c_str(), ios::binary);
		}
		voutput[pos]->write( reinterpret_cast<char*>( &x ), sizeof x );
		voutput[pos]->write( reinterpret_cast<char*>( &y ), sizeof y );
		voutput[pos]->write( reinterpret_cast<char*>( &z ), sizeof z );
		numberofpoints[pos]++;
	}
	for(int i=0; i<voutput.size(); i++) if(voutput[i]!=NULL) voutput[i]->close();
	
	int count = 0;
	for(float i=min_x; i<=max_x; i+=resolution) {
	for(float j=min_y; j<=max_y; j+=resolution) {
	for(float k=min_z; k<=max_z; k+=resolution)
	{
		index << i << " " << i+resolution << " ";
		index << j << " " << j+resolution << " ";
		index << k << " " << k+resolution << " "; 
		index << "s" << count << ".xyz" << " " << numberofpoints[count] << "\n";
		count++;
	} }}
	gettimeofday(&endTime, NULL);
	diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
	diff += (endTime.tv_usec - startTime.tv_usec);
	cout << "Time to build index: " << (diff / 1000L) << " ms" << endl;
}
