#include <iostream>
#include <fstream>
#include <vector>
#include <sstream>
#include <math.h>
#include <sys/time.h>

using namespace std;
int main(int argc, char** argv)
{
	//start timer
	struct timeval startTime, endTime; long diff;
	gettimeofday(&startTime, NULL);
	string indexlocation = "/media/Storage/gedebinindexsub/"; //location of the index
	
	bool notdone=true;
	while(notdone)
	{
	notdone=false;
	ifstream fin((indexlocation+"index.txt").c_str());
	ofstream fout((indexlocation+"index2.txt").c_str());
	long cloud_size;
	fin >> cloud_size;
	float min_x, max_x, min_y, max_y, min_z, max_z;
	fin >> min_x >> max_x >> min_y >> max_y >> min_z >> max_z;
	fout.precision(10);
	fout << cloud_size << endl;
	fout << min_x << " " << max_x << " " << min_y << " " << max_y << " " << min_z << " " << max_z << endl;
		
	float a,b,c,d,e,f;
	string filename;
	int numpoints;
	while(fin >> a >> b >> c >> d >> e >> f >> filename >> numpoints)
	{
		if(numpoints>500000)
		{
			ifstream binaryin( (indexlocation+filename).c_str(), ios::binary);
			string shortname = filename.substr(0,filename.length()-4);
			
			vector<ofstream*> voutput;
			voutput.resize(8);
			int regpoints[8];
			for(int i=0; i<8; i++) regpoints[i]=0; //initialise to zero
			string alpha[] = {"a","b","c","d","e","f","g","h"};
			
			float a2=(a+b)/2.0f;
			float c2=(c+d)/2.0f;
			float e2=(e+f)/2.0f;
			int pos = 0;
			for (size_t i = 0; i < numpoints; ++i)
			{
				float x,y,z;
				binaryin.read( reinterpret_cast<char*>( &x ), sizeof x );
				binaryin.read( reinterpret_cast<char*>( &y ), sizeof y );
				binaryin.read( reinterpret_cast<char*>( &z ), sizeof z );
				if(x < a2)
				{
					if(y < c2)
					{
						if(z<e2)pos=0;
						else pos=1;
					}
					else
					{
						if(z<e2)pos=2;
						else pos=3;
					}
				}
				else
				{
					if(y < c2)
					{
						if(z<e2)pos=4;
						else pos=5;
					}
					else
					{
						if(z<e2)pos=6;
						else pos=7;
					}
				}
				if(voutput[pos]==NULL)
				{
					voutput[pos] = new ofstream((indexlocation+shortname+alpha[pos]+".xyz").c_str(), ios::binary);
				}
				voutput[pos]->write( reinterpret_cast<char*>( &x ), sizeof x );
				voutput[pos]->write( reinterpret_cast<char*>( &y ), sizeof y );
				voutput[pos]->write( reinterpret_cast<char*>( &z ), sizeof z );
				regpoints[pos]++;
			}
						
			if(regpoints[0]>0) fout << a << " " << a2 << " " << c << " " << c2 << " " << e << " " << e2 << " " << shortname << "a.xyz" << " " << regpoints[0] << "\n";
			if(regpoints[1]>0) fout << a << " " << a2 << " " << c << " " << c2 << " " << e2 << " " << f << " " << shortname << "b.xyz" << " " << regpoints[1] << "\n";
			if(regpoints[2]>0) fout << a << " " << a2 << " " << c2 << " " << d << " " << e << " " << e2 << " " << shortname << "c.xyz" << " " << regpoints[2] << "\n";
			if(regpoints[3]>0) fout << a << " " << a2 << " " << c2 << " " << d << " " << e2 << " " << f << " " << shortname << "d.xyz" << " " << regpoints[3] << "\n";
			if(regpoints[4]>0) fout << a2 << " " << b << " " << c << " " << c2 << " " << e << " " << e2 << " " << shortname << "e.xyz" << " " << regpoints[4] << "\n";
			if(regpoints[5]>0) fout << a2 << " " << b << " " << c << " " << c2 << " " << e2 << " " << f << " " << shortname << "f.xyz" << " " << regpoints[5] << "\n";
			if(regpoints[6]>0) fout << a2 << " " << b << " " << c2 << " " << d << " " << e << " " << e2 << " " << shortname << "g.xyz" << " " << regpoints[6] << "\n";
			if(regpoints[7]>0) fout << a2 << " " << b << " " << c2 << " " << d << " " << e2 << " " << f << " " << shortname << "h.xyz" << " " << regpoints[7] << "\n";
			
			binaryin.close();
			remove((indexlocation+filename).c_str());
			for(int k=0; k<8; k++)
			{
				if(voutput[k]!=NULL) voutput[k]->close();
				if(regpoints[k]>=500000) notdone=true;
			}
		}
		else if(numpoints!=0) fout << a << " " << b << " " << c << " " << d << " " << e << " " << f << " " << filename << " " << numpoints << "\n";
	}
	
	fin.close();
	fout.close();
	remove((indexlocation+"index.txt").c_str());
	rename((indexlocation+"index2.txt").c_str(),(indexlocation+"index.txt").c_str());
	
	}
	gettimeofday(&endTime, NULL);
	diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
	diff += (endTime.tv_usec - startTime.tv_usec);
	cout << "Total time taken: " << (diff / 1000L) << " ms" << endl;
}
