#include <pcl/point_cloud.h>
#include <pcl/octree/octree.h>
#include <pcl/point_types.h>
#include <pcl/visualization/cloud_viewer.h>

#include <iostream>
#include <fstream>
#include <vector>
#include <ctime>

using namespace std;
int main (int argc, char** argv)
{
  struct timeval startTime, endTime; long diff;
  pcl::PointCloud<pcl::PointXYZ>::Ptr cloud (new pcl::PointCloud<pcl::PointXYZ>);

  // Read input file
  gettimeofday(&startTime, NULL);
  ifstream binin("/media/Storage/mosque.bin", ios::binary);
 
  cloud->width = 59242631; //mosque.xyz
  cloud->height = 1;
  cout << "Allocating memory... :-/" << endl;
  cloud->points.resize (cloud->width * cloud->height);
  cout << "Cloud contains " << cloud->width * cloud->height << " points" << endl;
  cout.precision(8);
  float intensity = 0;
  //string skipline;
  float x,y,z;
  for (size_t i = 0; i < cloud->points.size (); ++i)
  {
    binin.read( reinterpret_cast<char*>( &x ), sizeof x );
    binin.read( reinterpret_cast<char*>( &y ), sizeof y );
    binin.read( reinterpret_cast<char*>( &z ), sizeof z );
    cloud->points[i].x = x;
    cloud->points[i].y = y;
    cloud->points[i].z = z;
    cout << x << " " << y << " " << z << endl;
  }
  binin.close();
  gettimeofday(&endTime, NULL);
  diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
  diff += (endTime.tv_usec - startTime.tv_usec);
  std::cout << "Time to read input and build cloud: " << (diff / 1000L) << " ms" << std::endl;
    
  pcl::visualization::CloudViewer viewer ("Simple Cloud Viewer");
  viewer.showCloud (cloud);
  while (!viewer.wasStopped ())
  {
  }

}
