#include <pcl/point_cloud.h>
#include <pcl/point_types.h>
#include <pcl/visualization/cloud_viewer.h>

#include <iostream>
#include <fstream>
#include <vector>

using namespace std;
int main (int argc, char** argv)
{
	for(float x_start=-50.0f; x_start>-95.0f; x_start-=5.0f)
	{
	struct timeval startTime, endTime; long diff;
	gettimeofday(&startTime, NULL); //start the timer
	
	pcl::PointCloud<pcl::PointXYZ>::Ptr cloud (new pcl::PointCloud<pcl::PointXYZ>); //empty point cloud pointer
	ifstream fin("/media/Storage/mosque.xyz"); //open the root index file
		
	//user set region for extraction
	//float x_start=-87.4886, x_end=-36.8698, y_start=30.0367, y_end=79.6752, z_start=-7.49669, z_end=8.08327; //entire
	float x_end=-30.0, y_start=30.0, y_end=80.0, z_start=-8.0, z_end=9.0; //entire2
	//float x_start=-100.0, x_end=-20.0, y_start=20.0, y_end=90.0, z_start=-20.0, z_end=20.0; //entire+1
	//float x_start=-50.0, x_end=-30.0, y_start=40.0, y_end=70.0, z_start=-6.0, z_end=5.0; //tree stump
	//float x_start=-60.0, x_end=-20.0, y_start=30.0, y_end=70.0, z_start=-10.0, z_end=10.0; //tree stump+1
	//float x_start=-105.0, x_end=-60.0, y_start=-60.0, y_end=-20.0, z_start=-5.0,z_end=3.0; //small mosque
	//float x_start=-90.0, x_end=-80.0, y_start=-50.0, y_end=-40.0, z_start=-5.0,z_end=3.0; //small mosque
	//float x_start=-155.410202, x_end=71.37434387, y_start=-97.22502136, y_end=98.39588165, z_start=-41.2867775,z_end=70.65890503; //gede
	     
	
	float a,b,c;
	while(fin >> a >> b >> c)
	{
		if(x_start <= a && a < x_end && y_start <= b && b < y_end && z_start <= c && c < z_end)
		{
			pcl::PointXYZ newpoint(a,b,c);	
			cloud->push_back(newpoint);
		}
	}
	fin.close();
	
	cout << cloud->width << endl;
	gettimeofday(&endTime, NULL);
	diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
	diff += (endTime.tv_usec - startTime.tv_usec);
	cout << "Time to perform extraction: " << (diff / 1000L) << " ms" << endl;
	}
  
	//visualise point cloud
	/*pcl::visualization::CloudViewer viewer ("Simple Cloud Viewer");
	viewer.showCloud (cloud);
	while (!viewer.wasStopped ())
	{
	}*/

	
}
