#include <pcl/point_cloud.h>
#include <pcl/octree/octree.h>
#include <pcl/io/pcd_io.h>
#include <pcl/point_types.h>
#include <pcl/visualization/cloud_viewer.h>
#include <pcl/octree/octree_iterator.h>
#include <pcl/octree/octree_impl.h>
#include <pcl/octree/octree_nodes.h>

#include <iostream>
#include <fstream>
#include <vector>
#include <ctime>

using namespace std;
int main (int argc, char** argv)
{
  struct timeval startTime, endTime; long diff;
  pcl::PointCloud<pcl::PointXYZ>::Ptr cloud (new pcl::PointCloud<pcl::PointXYZ>);
  

  // Read input file
  //ifstream fin("/media/Storage/smallmosque.xyz");
  ifstream fin("/media/Storage/smallmosque.bin", ios::binary);
 
  
  cloud->width = 100000000; //timing
  //cloud->width = 59242631; //mosque.xyz
  //cloud->width = 25000000;
  //cloud->width = 365403; //mosque_down.xyz
  //cloud->width = 14626;
  //cloud->width = 224162339/12; //smallmosque.xyz
  cloud->height = 1;
  cloud->points.resize (cloud->width * cloud->height);
    
  gettimeofday(&startTime, NULL);
  float x,y,z;
  for (int i = 0; i < cloud->points.size (); ++i)
  {
    /*fin >> cloud->points[i].x;
    fin >> cloud->points[i].y;
    fin >> cloud->points[i].z;*/
    fin.read( reinterpret_cast<char*>( &x ), sizeof x );
    fin.read( reinterpret_cast<char*>( &y ), sizeof y );
    fin.read( reinterpret_cast<char*>( &z ), sizeof z );
    cloud->points[i].x = x;
    cloud->points[i].y = y;
    cloud->points[i].z = z;
    
    if((i+1)%5000000 == 0)
    {
    	gettimeofday(&endTime, NULL);
 		diff =  (endTime.tv_sec - startTime.tv_sec) * 1000000L;
  		diff += (endTime.tv_usec - startTime.tv_usec);
    	cout << (i+1) << " " << (diff / 1000L) << endl;
    }
  }
  fin.close();
 
  /*pcl::visualization::CloudViewer viewer ("Simple Cloud Viewer");
  viewer.showCloud (cloud);
  while (!viewer.wasStopped ())
  {
  }*/

}
